require 'open-uri'
require 'nokogiri'
require 'terminal-table'

module Muamba
  class Persistence
    URL = "http://websro.correios.com.br/sro_bin/txect01$.QueryList?P_LINGUA=001&P_TIPO=001&P_COD_UNI="

    def track(tag, tracking)
      muambas { |m| m.merge! tag => tracking }
    end

    def untrack(tag)
      muambas { |m| m.reject! {|k,v| k == tag } }
    end

    def list
      muambas { |m| puts m }
    end

    def wtf
      muambas do |muamba|
        muamba.each do |tag, tracking|
          puts "\n\n:::::::::::::::::::::::  #{tag} (#{tracking})  :::::::::::::::::::::::"
          html = Nokogiri::HTML open(URL + tracking)
          rows = []
          html.css("tr").each do |tr|
            rows << tr.css("td").map(&:text)
          end
          header = rows.shift
          rows.unshift :separator
          rows.unshift header
          puts Terminal::Table.new :rows => rows
        end
      end
    end

    def muambas
      begin
        File.open(File.expand_path("~/.muambas"), "r+") do |file|
          @muambas = Marshal.load(file.read) rescue {}
          yield @muambas
          file.truncate(0)
          file.rewind
          file.write Marshal.dump(@muambas)
        end

      rescue Errno::ENOENT
        File.open(File.expand_path("~/.muambas"), "w+") { |f| f.write "" }
        retry
      end
    end
  end
end
